// TRIM_FINAL_FINAL.cpp : This file contains the 'main' function. Program execution begins and ends there.
//

#include <iostream>
#include "trim_simulate.h"
#include "trim_class.h"
#include <vector>
int main()
{
    particle ion;
    class target target;
    target.layers[0].thickness = 1e7;
    simulate_parameter parameter;
    parameter.number_simulation = 1e4;
    parameter.method_theta_calculation = 1;
    simulate_result result;

    std::vector<double> E({ 10,11,12,13,14,15,16,17,18,20,22.5000000000000,25,27.5000000000000,30,32.5000000000000,35,37.5000000000000,40,45,50,55,60,65,70,80,90,100,110,120,130,140,150,160,170,180,200,225,250,275,300,325,350,375,400,450,500,550,600,650,700,800,900,1000,1100,1200,1300,1400,1500,1600,1700,1800,2000,2250,2500,2750,3000,3250,3500,3750,4000,4500,5000,5500,6000,6500,7000,8000,9000,10000});

    for (auto e : E) {
        particle ion_init(ion);
        ion_init.energy = e;
        class target target_init(target);
        simulate_parameter parameter_init(parameter);
        simulate_result result_init(result);
        for (int i = 0; i < target_init.number_layer; i++) {
            target_init.layers[i].average_atomic_number = 0;
            target_init.layers[i].average_atmoic_mass = 0;
            for (int j = 0; j < target_init.layers[i].components.size(); j++) {
                target_init.layers[i].average_atmoic_mass += target_init.layers[i].components[j].atomic_mass * target_init.layers[i].components[j].relative_amount;
                target_init.layers[i].average_atomic_number += target_init.layers[i].components[j].atomic_number * target_init.layers[i].components[j].relative_amount;
            }
            target_init.layers[i].average_number_density = target_init.layers[i].density * 0.6022 / target_init.layers[i].average_atmoic_mass;
        }
        target_init.layers_depth.resize(target_init.layers.size());
        for (int i = 0; i < target_init.number_layer; i++) {
            if (i == 0) {
                target_init.layers_depth[i] = target_init.layers[i].thickness;
            }
            else {
                target_init.layers_depth[i] = target_init.layers[i].thickness + target_init.layers_depth[i - 1];
            }
        }
        simulate(ion_init, target_init, parameter_init, result_init);
        std::cout << e << " " << result_init.projected_range << std::endl;
    }
    return 0;
}

// Run program: Ctrl + F5 or Debug > Start Without Debugging menu
// Debug program: F5 or Debug > Start Debugging menu

// Tips for Getting Started: 
//   1. Use the Solution Explorer window to add/manage files
//   2. Use the Team Explorer window to connect to source control
//   3. Use the Output window to see build output and other messages
//   4. Use the Error List window to view errors
//   5. Go to Project > Add New Item to create new code files, or Project > Add Existing Item to add existing code files to the project
//   6. In the future, to open this project again, go to File > Open > Project and select the .sln file
