#include "trim_electronic_loss_coff.h"

///*
//一个用来初始化元素数据数据库变量的函数，初始化待优化为编译期进行
//内容意义（按列计数）：
//0：原子序数
//1：最大丰度同位素原子量(atomic mass)
//2：最大丰度同位素原子质量(atomic weight)
//3：自然界丰度下全同位素平均原子质量
//4：固体密度(g/cm^3)
//5：固体密度(10^22 atoms/cm^3)
//6：固体中的费米速度(单位是波尔速度)
//7：离子屏蔽长度定义因子
//8-15：质子停止截面系数
//*/
//inline const boost::multi_array<double,2> initialize_loss_database() {
//    boost::multi_array<double, 2> database(boost::extents[92][16]);
//    std::ifstream out(".\\data\\elec_loss_table.dat", std::ifstream::in);//打开文件，为存放目录下的data.txt文件
//    std::string line, word;
//    std::array<double, 16> element = { 0 };//用来存一行
//    int i = 0;
//    while (std::getline(out, line)) {//读一行，放到line里
//        int j = 0;
//        std::istringstream record(line);
//        while (record >> word) { //从一行里读一个数据
//            element[j] = stod(word); //将数据字符串转化为double类型
//            j++;
//        }
//        for (int k = 0; k < 16; k++) {
//            database[i][k] = element[k]; //将一行存进数组
//            if (k == 5) {
//                database[i][k] *= 1e22;
//            }
//        }
//        i++;
//    }
//    /*for (int i = 0; i < 92; i++) {
//        for (int j = 0; j < 16; j++) {
//            std::cout << database[i][j] << " ";
//        }
//        std::cout << std::endl;
//    }*/
//    return database;
//};
///*
//计算给定入射氢核（质子）-靶的电子性能量损失系数
//输入：
//Z1:入射离子原子序数
//M1:入射粒子原子量
//Z2:靶粒子原子序数
//E1:入射电子能量（keV）
//输出:
//SP:电子性能量损失系数
//*/
//inline double calculate_electronic_loss_hydrogen(const boost::multi_array<double, 2>& database, const unsigned int Z2, const double E1) {
//    constexpr double PEO = 25.0;//波尔速度对应的能量,在此速度之下停止能与粒子速度成正比
//    //在波尔速度之下的特殊情况，详情参见下面的if语句
//    double PE = std::max(PEO, E1);
//    //拟合公式，形式参见文献SRIO
//    double SL = database[Z2 - 1][8] * pow(PE, database[Z2 - 1][9]) + database[Z2 - 1][10] * pow(PE, database[Z2 - 1][11]);
//    double SH = database[Z2 - 1][12] / pow(PE, database[Z2 - 1][13]) * log(database[Z2 - 1][14] / PE + database[Z2 - 1][15] * PE);
//    double SP = SL * SH / (SL + SH);
//    //低速情况下，停止能与速度的0.9次方成正比（除了Li,Be,C,H,He,它们是0.5次方成正比），因为是动能所以指数除2
//    if (E1 <= PEO) {
//        double VELPWR = 0.45;
//        if (Z2 <= 6) {
//            VELPWR = 0.25;
//        }
//        SP = SP * pow(E1 / PEO, VELPWR);
//    }
//    return SP;
//}
///*
//计算给定入射离子-靶的电子性能量损失系数
//输入：
//Z1:入射离子原子序数
//M1:入射粒子原子量
//Z2:靶粒子原子序数
//E1:入射电子能量（keV）
//输出:
//SP:电子性能量损失系数(eV/Å^2)
//*/
//inline double calculate_elec_loss_coff_trim85(const unsigned int Z1, const double M1, const unsigned int Z2, const double E1) {
//    static const boost::multi_array<double, 2> database = initialize_loss_database();
//    double E = E1 / M1;//每原子质量能量比
//    double SP;//电子性能量损失系数
//    switch (Z1) {
//        //入射离子为氢情况
//    case 1: {
//        //因为计算氢核的公式给出的结果单位是eV/(10^15 atoms/cm^2，要进行单位换算，乘10
//        SP = calculate_electronic_loss_hydrogen(database, Z2, E);
//        break;
//    }
//          //入射离子为氦情况
//    case 2: {
//        double HEO = 1.0;
//        double HE = std::max(HEO, E);
//        //将He核等效为对应的H核结果
//        double B = log(HE);
//        //最后的是0.00175还是0.001465待确定
//        double A = 0.2865 + 0.1266 * B - 0.001429 * pow(B, 2) + 0.02402 * pow(B, 3) - 0.01135 * pow(B, 4) + 0.001475 * pow(B, 5);
//        double HEH = 1.0 - exp(-std::min(30.0, A));
//        A = 1.0 + (0.007 + 0.00005 * Z2) * exp(-pow(7.6 - std::max(0.0, log(HE)), 2));
//        HEH = HEH * A * A;
//        //计算对应的氢核停止能
//        SP = calculate_electronic_loss_hydrogen(database, Z2, HE);
//        //转化为对应的氦核停止能
//        SP = SP * HEH * 4;
//        //He原子速度小于1keV/amu时，其停止能与速度成正比
//        if (E <= HEO) {
//            SP = SP * sqrt(E / HEO);
//        }
//        break;
//    }
//    default: {
//        constexpr double YRMIN = 0.13;
//        double VRMIN = 1.0;
//        double V = sqrt(E / 25) / database[Z2 - 1][6];
//        double VR;
//        if (V < 1.0) {
//            VR = (0.75 * database[Z2 - 1][6]) * (1 + 2.0 / 3 * pow(V, 2) - pow(V, 4) / 15.0);
//        }
//        else {
//            VR = V * database[Z2 - 1][6] * (1 + 1 / pow(V, 2) / 5.0);
//        }
//        double YR = std::max(YRMIN, VR / pow(Z1, 2.0 / 3));
//        YR = std::max(YR, VRMIN / pow(Z1, 2.0 / 3));
//        double A = -0.803 * pow(YR, 0.3) + 1.3167 * pow(YR, 0.6) + 0.38157 * YR + 0.008983 * pow(YR, 2);
//        double Q = std::min(1.0, std::max(0.0, 1.0 - exp(-std::min(A, 50.0))));
//        double B = (std::min(0.43, std::max(0.32, 0.12 + 0.025 * Z1))) / pow(Z1, 1.0 / 3);
//        double L0 = (0.8 - Q * std::min(1.2, 0.6 + Z1 / 30.0)) / pow(Z1, 1.0 / 3);
//        double L1, Q1;
//        if (Q < 0.2) {
//            L1 = 0.0;
//        }
//        else if (Q < std::max(0.0, 0.9 - 0.025 * Z1)) {
//            Q1 = 0.2;
//            L1 = B * (Q - 0.2) / abs(std::max(0.0, 0.9 - 0.025 * Z1) - 0.2000001);
//        }
//        else if (Q < std::max(0.0, 1.0 - 0.025 * std::min(16.0, 1.0 * Z1))) {
//            L1 = B;
//        }
//        else {
//            L1 = B * (1.0 - Q) / (0.025 * std::min(16.0, 1.0 * Z1));
//        }
//        double L = std::max(L1, L0 * database[Z1 - 1][7]);
//        double ZETA = Q + 1.0 / (2.0 * pow(database[Z2 - 1][6], 2)) * (1.0 - Q) * log(1 + pow(4 * L * database[Z2 - 1][6] / 1.919, 2));
//        A = -pow(7.6 - std::max(0.0, log(E)), 2);
//        ZETA = ZETA * (1.0 + 1.0 / pow(Z1, 2) * (0.18 + 0.0015 * Z2) * exp(A));
//        if (YR <= std::max(YRMIN, VRMIN / pow(Z1, 2.0 / 3))) {
//            VRMIN = std::max(VRMIN, YRMIN * pow(Z1, 2.0 / 3));
//            double VMIN = 0.5 * (VRMIN + sqrt(std::max(0.0, pow(VRMIN, 2) - 0.8 * pow(database[Z2 - 1][6], 2))));
//            double EEE = 25 * pow(VMIN, 2);
//            SP = calculate_electronic_loss_hydrogen(database, Z2, EEE);
//            double POWER = 0.5;
//            if ((Z2 == 6) || (((Z2 == 14) || (Z2 == 32)) && (Z1 <= 19))) {
//                POWER = 0.375;
//            }
//            SP = SP * pow(ZETA * Z1, 2) * pow(E / EEE, POWER);
//        }
//        else {
//            SP = calculate_electronic_loss_hydrogen(database, Z2, E);
//            SP = SP * pow(ZETA * Z1, 2);
//        }
//        break;
//    }
//    }
//    return 10*SP;
//}
