#include "trim_scatter_theta.h"

///*
//使用MAGIC_FORMULA计算散射角
//*/
//inline double get_scatter_theta_cos_magic_formula(const double epsilon,const double b) {
//    double r = b;
//    double rr = -2.7 * log(epsilon * b);
//    if (rr >= b) {
//        rr = -2.7 * log(epsilon * rr);
//        if (rr >= b) {
//            r = rr;
//        }
//    }
//    double q,v,v1;
//    do {
//        double ex1 = 0.18175 * exp(-3.1998 * r);
//        double ex2 = 0.50986 * exp(-0.94229 * r);
//        double ex3 = 0.28022 * exp(-0.4029 * r);
//        double ex4 = 0.028171 * exp(-0.20162 * r);
//        v = (ex1 + ex2 + ex3 + ex4) / r;
//        v1 = -(v + 3.1998 * ex1 + 0.94229 * ex2 + 0.4029 * ex3 + 0.20162 * ex4) / r;

//        double fr = b * b / r + v * r / epsilon - r;
//        double fr1 = -b * b / (r * r) + (v + v1 * r) / epsilon - 1.0;
//        q = fr / fr1;
//        r = r - q;
//    } while (abs(q / r) > 0.001);

//    double roc = -2.0 * (epsilon - v) / v1;
//    double sqe = sqrt(epsilon);

//    double cc = (0.011615 + sqe) / (0.0071222 + sqe);
//    double aa = 2.0 * epsilon * (1 + 0.99229 / sqe) * pow(b, cc);
//    double ff = (sqrt(pow(aa, 2)+1.0)-aa) * (9.3066 + epsilon) / (14.813 + epsilon);

//    double delta = (r - b) * aa * ff / (ff + 1.0);

//    return (b + delta + roc) / (r + roc);
//}
///*
//快速级数法求散射角
//*/
//inline double get_scatter_theta_fast_indexing_method(double epsilon, double s, unsigned int N) {
//    auto phi = [=](double x)->double {return 0.1818 * exp(-3.2 * x) + 0.5099 * exp(-0.9423 * x) + 0.2802 * exp(-0.4028 * x) + 0.02817 * exp(-0.2016 * x); };
//    auto phi_derivate = [=](double x)->double {return -0.58176 * exp(-3.2 * x) - 0.48047877 * exp(-0.9423 * x) - 0.11286456 * exp(-0.4028 * x) - 0.005679072 * exp(-0.2016 * x); };

//    auto x0_fun = [=](double x)->double {return 1 - phi(x) / (x * epsilon) - pow(s / x, 2); };
//    auto x0_fun_derivate = [=](double x)->double {return -phi_derivate(x) / (x * epsilon) + phi(x) / (x * x * epsilon) + 2 * s * s / x / x / x; };
//    double x0 = get_zero_newton(x0_fun, x0_fun_derivate, s);

//    auto H = [=](double u)->double {return sqrt((1 - u * u) / (1 - phi(x0 / u) / (x0 / u * epsilon) - pow(s / (x0 / u), 2))); };
//    double theta = 0;
//    for (unsigned int j = 1; j <= N / 2; j++) {
//        double x = H(cos(1.0 * (2.0 * j - 1) / (2.0 * N) * std::numbers::pi));
//        theta += x;
//    }
//    theta = std::numbers::pi - 2 * std::numbers::pi * s / N / x0 * theta;
//    return theta;
//}
///*
//表格初始化
//*/
//inline const boost::multi_array<double, 2> initialize_table(std::string database_name) {
//    std::vector<std::vector<double>> database_in;
//    std::ifstream out(".\\data\\"+database_name, std::ifstream::in);//打开文件，为存放目录下的data.txt文件
//    std::string line, word;
//    std::vector<double> element;//用来存一行
//    int i = 0;
//    while (std::getline(out, line)) {//读一行，放到line里
//        int j = 0;
//        std::istringstream record(line);
//        while (record >> word) { //从一行里读一个数据
//            element.push_back(stod(word)); //将数据字符串转化为double类型
//        }
//        database_in.push_back(element);
//        i++;
//        element.clear();
//    }
//    boost::multi_array<double, 2> database(boost::extents[database_in.size()][database_in[0].size()]);
//    for (int i = 0; i < database_in.size(); i++) {
//        for (int j = 0; j < database_in[0].size(); j++) {
//            database[i][j] = database_in[j][i];
//        }
//    }
//    return database;
//}
///*
//采用双线性内插法计算角度值，epsilon需要转为对数进行计算
//目前10000个点进行线性内插，与精确计算差距在5%以内
//*/
//inline double get_scatter_theta_table(const double epsilon, const double b) {
//    static const boost::multi_array<double, 2> database=initialize_table("interpolation_table.dat");
//    constexpr double emin = -8;
//    constexpr double emax = 2;
//    constexpr double estep = 0.1;
//    constexpr double bmin = 0;
//    constexpr double bmax = 100;
//    constexpr double bstep = 1;
//    static std::vector<double> e_list = range_vec(emin, emax, estep);
//    static std::vector<double> b_list = range_vec(bmin, bmax, bstep);

//    double e = log10(epsilon);
//    if (e >= emin && e <= emax && b >= bmin && b <= bmax) {
//        unsigned i=0, j=0;
//        while (e>e_list[i+1]) {
//            ++i;
//        }
//        while (b > b_list[j + 1]) {
//            ++j;
//        }
//        return (database[i][j] * (e_list[i + 1] - e) * (b_list[j + 1] - b)\
//            + database[i + 1][j] * (e - e_list[i]) * (b_list[j + 1] - b)\
//            + database[i][j + 1] * (e_list[i + 1] - e) * (b - b_list[j])\
//            + database[i + 1][j + 1] * (e - e_list[i]) * (b - b_list[j])) / (estep * bstep);
//    }
//    else {
//        return get_scatter_theta_fast_indexing_method(epsilon, b);
//    }
//}
