#include "trim_simulate.h"
/*
从输入文件中读取此次模拟参数
格式见附件文档
*/
/*
inline void input_parameter(particle& particle_in, target& target_in, simulate_parameter& parameter_in) {
    std::ifstream out(".\\input.dat", std::ifstream::in);//打开文件，为存放目录下的input.dat文件
    std::string line, word;
    int i = 0;//行计数
    int j = -1;//靶层数计数
    int k = -1;//靶组分计数
    std::vector<double> line_static;
    while (std::getline(out, line)) {//读一行，放到line里
        std::istringstream record(line);
        while (record >> word) { //从一行里读一个数据
            line_static.push_back(stod(word)); //将数据字符串转化为double类型
        }
        ++i;
        switch (i) {
        case 1:
            particle_in.energy = line_static[0];
            particle_in.atomic_number = (int)round(line_static[1]);
            if (line_static[2] == 0) {
                //particle_in.atomic_mass = AtomicMass[particle_in.atomic_number];
                particle_in.atomic_mass = periodic_table_database[particle_in.atomic_number - 1].most_isotopic_weight;
            }
            else {
                particle_in.atomic_mass = line_static[2];
            }
            break;
        case 2:
            parameter_in.number_simulation = (int)round(line_static[0]);
            if (line_static[1] == 0) {
                parameter_in.final_energy = std::max(5.0, 0.1 * particle_in.energy);
            }
            else {
                parameter_in.final_energy = line_static[1];
            }
            parameter_in.displacement_energy = line_static[2];
            if (line_static[3] == 0) {
                parameter_in.minimum_transfered_energy = 5;
            }
            else {
                parameter_in.final_energy = line_static[3];
            }
            break;
        case 3:
            target_in.number_layer = (int)round(line_static[0]);
            target_in.layers.resize(boost::extents[target_in.number_layer]);
            break;
        case 4:
            ++j;
            k = -1;
            target_in.layers[j].thickness = line_static[0];
            target_in.layers[j].density = line_static[1];
            target_in.layers[j].number_componet = (int)round(line_static[2]);
            target_in.layers[j].components.resize(boost::extents[target_in.layers[j].number_componet]);
            break;
        case 5:
            --i;
            ++k;
            target_in.layers[j].components[k].atomic_number = (int)round(line_static[0]);
            target_in.layers[j].components[k].atomic_mass = line_static[1];
            target_in.layers[j].components[k].relative_amount = line_static[2];
            if (k + 1 >= int(target_in.layers[j].number_componet)) {
                target_in.layers[j].average_atmoic_mass = 0;
                target_in.layers[j].average_atomic_number = 0;
                for (unsigned int q = 0; q < target_in.layers[j].number_componet; q++) {
                    target_in.layers[j].average_atmoic_mass += target_in.layers[j].components[q].atomic_mass * target_in.layers[j].components[q].relative_amount;
                    target_in.layers[j].average_atomic_number += target_in.layers[j].components[q].atomic_number * target_in.layers[j].components[q].relative_amount;
                }
                target_in.layers[j].average_number_density = target_in.layers[j].density * 0.6022 / target_in.layers[j].average_atmoic_mass;
                i--;
            }
            break;
        }
        line_static.clear();
    }
    //计算片层深度
    target_in.layers_depth.resize(boost::extents[target_in.number_layer]);
    target_in.layers_depth[0] = target_in.layers[0].thickness;
    if (target_in.number_layer > 1) {
        for (unsigned q = 1; q < target_in.number_layer; q++) {
            target_in.layers_depth[q] += target_in.layers_depth[q - 1] + target_in.layers[q].thickness;
        }
    }
}
*/
/*
模拟
*/
//inline void simulate(particle& particle_in, target& target_in, simulate_parameter& parameter_in,simulate_result& result) {
//    //别名表
//    const double& E0 = particle_in.energy;
//    const unsigned& Z1 = particle_in.atomic_number;
//    const double& M1 = particle_in.atomic_mass;
//    double& x = particle_in.displacement[0];
//    double& y = particle_in.displacement[1];
//    double& z = particle_in.displacement[2];
//    std::array<double, 3>& direction = particle_in.direction;

//    const unsigned& N = parameter_in.number_simulation;
//    const double& Ef = parameter_in.final_energy;
//    const double& Ed = parameter_in.displacement_energy;
//    const double& tmin = parameter_in.minimum_transfered_energy;

//    const double max_depth = *(target_in.layers_depth.end() - 1);

//    //约化长度和约化能量计算lambda表达式
//    auto reduced_length = [](unsigned Z1, unsigned Z2)->\
//        double{ return 0.5292 * 0.8853 / (pow(Z1, 0.23) + pow(Z2, 0.23)); };
//    auto reduced_energy_coff = [](unsigned Z1, unsigned Z2, double M1, double M2, double a)\
//        ->double{return a * M2 / (Z1 * Z2 * 14.4 * (M1 + M2)); };

//    for (unsigned n = 0; n < N; n++) {
//        //单位换算
//        double E = E0 * 1000;
//        unsigned ic = 0;

//        x = 0;
//        y = 0;
//        z = 0;
//        direction = { 0,0,1 };

//        double path_length_sum=0;

//        while (1) {
//            //求粒子在哪层
//            unsigned i = 0;//层数计数器
//            while (z > target_in.layers_depth[i]) {
//                i++;
//            }
//            //暂时别名表
//            double& Z2L = target_in.layers[i].average_atomic_number;
//            double& M2L = target_in.layers[i].average_atmoic_mass;
//            const double& arho = target_in.layers[i].average_number_density;

//            //此层的平均约化长度和约化能量
//            double a = reduced_length(Z1, Z2L);
//            double epsilon_coff = reduced_energy_coff(Z1, Z2L, M1, M2L, a);
//            double epsilon = epsilon_coff * E;

//            //求解自由飞行路径和碰撞参数
//            double epsilon_dg = tmin * epsilon_coff * pow(M1 + M2L, 2) / (4 * M1 * M2L);
//            double zeta = sqrt(epsilon * epsilon_dg);
//            double pmax = a / (zeta + sqrt(zeta) + 0.125 * pow(zeta, 0.1));
//            double ls = 1.0 / (std::numbers::pi * pow(pmax, 2) * arho);

//            ++ic;
//            if (ic == 1) {
//                ls = get_rand() * std::min(ls, 0.01 * max_depth);
//            }

//            double p = pmax * sqrt(get_rand());

//            //求该层中哪个离子参与碰撞
//            unsigned j = 0;
//            double rand = get_rand();
//            while (rand > target_in.layers[i].components[j].relative_amount) {
//                rand -= target_in.layers[i].components[j].relative_amount;
//                ++j;
//            }

//            const unsigned& Z2 = target_in.layers[i].components[j].atomic_number;
//            const unsigned& M2 = target_in.layers[i].components[j].atomic_mass;

//            a = reduced_length(Z1, Z2);
//            epsilon_coff = reduced_energy_coff(Z1, Z2, M1, M2, a);
//            epsilon = epsilon_coff * E;
//            double b = p / a;

//            //以下可以切换不同求电子停止能系数的函数
//            double electronic_loss_coff = 0;
//            for (int m = 0; m < target_in.layers[i].number_componet; m++) {
//                electronic_loss_coff += calculate_elec_loss_coff_trim85(Z1, M1, target_in.layers[i].components[j].atomic_number, E / 1000) \
//                    * target_in.layers[i].components[m].relative_amount \
//                    * target_in.layers[i].average_number_density;
//            }

//            //求电子性能量损失
//            double electronic_loss = electronic_loss_coff * ls;

//            //求解散射角
//            double st, ct, s2;//sin(theta),cos(theta),sin^2(theta/2)
//            //能量较大时接近于修正后的卢瑟福散射
//            if (epsilon > 10) {
//                s2 = 1.0 / (1.0 + (1.0 + b * (1.0 + b)) * pow(2.0 * epsilon * b, 2));
//                double c2 = 1.0 - s2;
//                ct = 2.0 * c2 - 1.0;
//                st = sqrt(1.0 - ct * ct);
//            }
//            //能量较小时可使用不同方法进行计算
//            else {
//                double co = get_scatter_theta_cos_magic_formula(epsilon, b);
//                //double co = cos(get_scatter_theta_fast_indexing_method(epsilon, b));
//                double c2 = co * co;
//                s2 = 1.0 - c2;
//                ct = 2.0 * c2 - 1.0;
//                st = sqrt(1.0 - ct * ct);
//            }

//            //计算核性能量损失
//            double ec = 4.0 * (M1 / M2) / pow(1 + M1 / M2, 2);
//            double nuclear_loss = ec * s2 * E;

//            double straggling_coff = 0;
//            for (int m = 0; m < target_in.layers[i].number_componet; m++) {
//                straggling_coff += calculate_straggling_coff(Z1, M1, E, target_in.layers[i].components[j].atomic_number, target_in.layers[i].average_number_density) \
//                    * target_in.layers[i].components[m].relative_amount \
//                    * target_in.layers[i].average_number_density;
//            }

//            //= calculate_straggling_coff(Z1, M1, E, Z2, target_in.layers[i].average_number_density);
//            double straggling_loss = straggling_coff * boost::math::erf_inv(get_rand() * 2 - 1) * sqrt(2);

//            //计算能量变换
//            E -= (electronic_loss + nuclear_loss + straggling_loss);

//            //将角度变回实验室参考系
//            double psi = atan2(st, ct + M1 / M2);
//            if (psi < 0) {
//                psi += std::numbers::pi;
//            }
//            //随机得到一个水平角
//            double phi = 2.0 * std::numbers::pi * get_rand();
//            //粒子位移
//            x += ls * direction[0];
//            y += ls * direction[1];
//            z += ls * direction[2];

//            path_length_sum+=ls;

//            //粒子速度角度变化
//            rotate(direction, psi, phi);
//            if (E <= Ef) {
//                ++result.num_stopped;
//                result.projected_range += z/result.num_stopped+result.projected_range*(result.num_stopped-1)/result.num_stopped;
//                result.range+=path_length_sum/result.num_stopped+result.range*(result.num_stopped-1)/result.num_stopped;
//                //std::cout << "The particle stopped!" << std::endl;
//                //std::cout << "Now the average range is: " << result.projected_range << " Å!" << std::endl;
//                break;
//            }
//            else if (z > max_depth) {
//                ++result.num_transmitted;
//                //std::cout << "The particle transmitted!" << std::endl;
//                break;
//            }
//            else if (z <= 0) {
//                ++result.num_backscatted;
//                //std::cout << "The particle backscatted!" << std::endl;
//                break;
//            }
//        }
//    }

//}
